-- Test order_surroundings_highlights
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(11);

set search_path to camper, public;

select has_function('camper', 'order_surroundings_highlights', array['integer[]']);
select function_lang_is('camper', 'order_surroundings_highlights', array['integer[]'], 'sql');
select function_returns('camper', 'order_surroundings_highlights', array['integer[]'], 'void');
select isnt_definer('camper', 'order_surroundings_highlights', array['integer[]']);
select volatility_is('camper', 'order_surroundings_highlights', array['integer[]'], 'volatile');
select function_privs_are('camper', 'order_surroundings_highlights', array ['integer[]'], 'guest', array[]::text[]);
select function_privs_are('camper', 'order_surroundings_highlights', array ['integer[]'], 'employee', array[]::text[]);
select function_privs_are('camper', 'order_surroundings_highlights', array ['integer[]'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'order_surroundings_highlights', array ['integer[]'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate surroundings_highlight cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into surroundings_highlight (surroundings_highlight_id, company_id, media_id, name, description)
values (3, 1, 2, 'A', '')
     , (4, 1, 2, 'B', '')
     , (5, 1, 2, 'C', '')
     , (6, 1, 2, 'D', '')
     , (7, 1, 2, 'E', '')
;

select lives_ok(
	$$ select order_surroundings_highlights('{5,7,6,3,4}') $$,
	'Should be able to sort surroundings highlights using their ids'
);

select bag_eq(
	$$ select surroundings_highlight_id, position from surroundings_highlight $$,
	$$ values (5, 1)
	        , (7, 2)
	        , (6, 3)
	        , (3, 4)
	        , (4, 5)
	$$,
	'Should have sorted all surroundings highlights.'
);


select *
from finish();

rollback;
